<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfResGuestsTypeResGuest ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfResGuestsTypeResGuest extends AbstractStructArrayBase
{
    /**
     * The ResGuest
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgResGuest[]
     */
    public $ResGuest;
    /**
     * Constructor method for ArrayOfResGuestsTypeResGuest
     * @uses DgArrayOfResGuestsTypeResGuest::setResGuest()
     * @param \dgsoft\StructType\DgResGuest[] $resGuest
     */
    public function __construct(array $resGuest = array())
    {
        $this
            ->setResGuest($resGuest);
    }
    /**
     * Get ResGuest value
     * @return \dgsoft\StructType\DgResGuest[]|null
     */
    public function getResGuest()
    {
        return $this->ResGuest;
    }
    /**
     * Set ResGuest value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgResGuest[] $resGuest
     * @return \dgsoft\ArrayType\DgArrayOfResGuestsTypeResGuest
     */
    public function setResGuest(array $resGuest = array())
    {
        foreach ($resGuest as $arrayOfResGuestsTypeResGuestResGuestItem) {
            // validation for constraint: itemType
            if (!$arrayOfResGuestsTypeResGuestResGuestItem instanceof \dgsoft\StructType\DgResGuest) {
                throw new \InvalidArgumentException(sprintf('The ResGuest property can only contain items of \dgsoft\StructType\DgResGuest, "%s" given', is_object($arrayOfResGuestsTypeResGuestResGuestItem) ? get_class($arrayOfResGuestsTypeResGuestResGuestItem) : gettype($arrayOfResGuestsTypeResGuestResGuestItem)), __LINE__);
            }
        }
        $this->ResGuest = $resGuest;
        return $this;
    }
    /**
     * Add item to ResGuest value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgResGuest $item
     * @return \dgsoft\ArrayType\DgArrayOfResGuestsTypeResGuest
     */
    public function addToResGuest(\dgsoft\StructType\DgResGuest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgResGuest) {
            throw new \InvalidArgumentException(sprintf('The ResGuest property can only contain items of \dgsoft\StructType\DgResGuest, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ResGuest[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgResGuest|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgResGuest|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgResGuest|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgResGuest|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgResGuest|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ResGuest
     */
    public function getAttributeName()
    {
        return 'ResGuest';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfResGuestsTypeResGuest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
